package jp.gr.java_conf.ykhr.eclipse.plugin.autocp;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

public abstract class AutoCpAction implements IObjectActionDelegate {
    
    private ISelection selection;

    public void setActivePart(IAction action, IWorkbenchPart targetPart) {
    }

    public void run(IAction action) {
        if (!(selection instanceof IStructuredSelection)) {
            return;
        }
        
        IStructuredSelection sselection = (IStructuredSelection) selection;
        if (sselection.isEmpty()) {
            return;
        }
        
        Object element = sselection.getFirstElement();
        if (!(element instanceof IAdaptable)) {
            return;
        }
        
        IProject project = (IProject) ((IAdaptable) element).getAdapter(IProject.class);
        if (project == null) {
            return;
        }
        
        try {
            doRun(project);
        } catch (CoreException e) {
            Activator.logError(e);
        }
    }

    public void selectionChanged(IAction action, ISelection selection) {
        this.selection = selection;
    }
    
    protected abstract void doRun(IProject project) throws CoreException;

}
