package jp.gr.java_conf.ykhr.eclipse.plugin.junitreporter.main;

import java.io.File;
import java.io.StringWriter;

import javax.xml.transform.Result;
import javax.xml.transform.Transformer;
import javax.xml.transform.stream.StreamResult;

import jp.gr.java_conf.ykhr.eclipse.plugin.junitreporter.ReportProperty;


public class MultiHtmlConverter extends HtmlConverter {
    
    public MultiHtmlConverter(String xml, String dest, ReportProperty prop) {
        super(xml, dest, prop);
    }
    
    protected Result getTransformResult() {
        // dummy
        return new StreamResult(new StringWriter());
    }
    
    protected void postConvert() {
        // do nothing
    }
    
    protected void preConvert() {
        File outputDir = new File(dest);
        if (!outputDir.exists()) {
            outputDir.mkdirs();
        }
    }
    
    protected void configTransformer(Transformer tf) {
        tf.setParameter("output.dir", dest);
    }
    
}
